<?php

App::uses('EvTemplatesAppModel', 'EvTemplates.Model');

abstract class AttachmentBlock extends EvTemplatesAppModel
{
    public $belongsTo = array(
        'Template' => array(
            'className' => 'EvTemplates.Template'
        )
    );

    /**
     * redefine the beforeSave to add checks for the name. Default to main if none set
     * Also serialize the blockFields
     */
    public function beforeSave($options = array())
    {
        $return = parent::beforeSave($options);

        // default any blocks with no name to "Main"
        if (empty($this->data[$this->alias]['name'])) {

            $this->data[$this->alias]['name'] = 'Main';
        }

        // camelCase any names so we can get MainImage / ListingImage / GalleryThumbImage
        $this->data[$this->alias]['name'] = InflectorExt::camelize($this->data[$this->alias]['name']);

        // Serialise any select fields
        $this->data[$this->alias]['blockFields'] = json_encode($this->data[$this->alias]['blockFields']);

        return $return;
    }


    /**
     * redefine the afterFind to unserialize any fields
     *
     */
    public function afterFind($results, $primary = false)
    {
        $results = parent::afterFind($results, $primary);

        if (! empty($results)) {

            foreach ($results as $key => $item) {

                if (! empty($item[$this->alias]['blockFields'])) {

                   $results[$key][$this->alias]['blockFields'] = json_decode($item[$this->alias]['blockFields'], true);
                }
            }
        }

        return $results;
    }
}
